﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;

namespace CustomSorter
{
    public static class ListExtension
    {
        public static void Sort<T, TResult>(this IList<T> source, Expression<Func<T, TResult>> property, string order) where T : class
        {
            Sort(source, property, order, StringComparison.CurrentCulture);
        }

        public static void Sort<T, TResult>(this IList<T> source, Expression<Func<T, TResult>> property, string order, StringComparison comparison) where T : class
        {
            var propertyList = new List<Expression<Func<T, TResult>>>();
            propertyList.Add(property);

            var orderList = new List<string>();
            orderList.Add(order);

            var sorter = new Sorter<T, TResult>();
            sorter.Add(property, order, comparison);

            sorter.Sort(source);
        }

        public static void Sort<T, TResult>(this IList<T> source, Sorter<T, TResult> sorter) where T : class
        {
            sorter.Sort(source);
        }
    }

   
}


