﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Xunit;
using Xunit.Extensions;

namespace GenericGridViewHelper.Specifications.SortingDirectionSpec
{
    public class When_get_sort_direction_for_the_first_time : Specification
    {
        private string _column = "ColumnA";
        private StateBag _viewState = new StateBag();

        public override void Observe()
        {
            SortingHelper.GetSortDirection(_column, _viewState);
        }

        [Observation]
        public void should_save_the_colomn_and_ascending_sort_direction_in_the_view_data()
        {
            _viewState[Const.SortExpression].ShouldEqual(_column);
            _viewState[Const.SortDirection].ShouldEqual(SortDirection.Ascending);
        }
    }

    public class When_get_sort_direction_using_the_same_column_for_the_second_time : Specification
    {
        private string _column = "ColumnA";
        private StateBag _viewState = new StateBag();

        public override void Observe()
        {
            SortingHelper.GetSortDirection(_column, _viewState);

            SortingHelper.GetSortDirection(_column, _viewState);
        }

        [Observation]
        public void should_save_the_colomn_and_descending_sort_direction_in_the_view_data()
        {
            _viewState[Const.SortExpression].ShouldEqual(_column);
            _viewState[Const.SortDirection].ShouldEqual(SortDirection.Descending);
        }
    }

    public class When_get_sort_direction_using_the_a_different_column : Specification
    {
        private string _column = "ColumnA";
        private string _anotherColumn = "ColumnB";
        private StateBag _viewState = new StateBag();

        public override void Observe()
        {
            SortingHelper.GetSortDirection(_column, _viewState);

            SortingHelper.GetSortDirection(_anotherColumn, _viewState);
        }

        [Observation]
        public void should_save_the_colomn_and_ascending_sort_direction_in_the_view_data()
        {
            _viewState[Const.SortExpression].ShouldEqual(_anotherColumn);
            _viewState[Const.SortDirection].ShouldEqual(SortDirection.Ascending);
        }
    }
}
